Index: c/src/lib/libbsp/i386/pc386/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/start/start.S,v
retrieving revision 1.11
diff -p -u -u -r1.11 start.S
--- c/src/lib/libbsp/i386/pc386/start/start.S	22 Mar 2008 14:01:49 -0000	1.11
+++ c/src/lib/libbsp/i386/pc386/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -88,21 +88,42 @@ speakl:	jmp	speakl             # and SPI
         cli			# DISABLE INTERRUPTS!!!
 	cld
 
-		/* Save multiboot info */
-		cmp 	$0x2badb002,eax
-		jne		1f
-		/* We have multiboot info; let's hope DS and ES are OK... */
-		movl	ebx, SYM(_boot_multiboot_info_p)
-		/* Check for memory size info and save */
-		movl	ebx, esi
-		movl	$SYM(_boot_multiboot_info), edi
-		movsd
-		/* only save flag 1 since that's the only data we save */
-		and		$1,-4(edi)
-		je		1f
-		movl	$2,ecx
-		rep movsd
-1:
+	/* Save multiboot info if we detect a multiboot loader */
+	cmp 	$0x2badb002,eax
+	jne	2f
+	
+	/* We have multiboot info; let's hope DS and ES are OK... */
+	movl	ebx, SYM(_boot_multiboot_info_p)
+	/* Check for memory size info and save */
+	movl	ebx, esi
+	movl	(esi), eax
+	movl	eax, ebx
+	movl	$SYM(_boot_multiboot_info), edi
+ 	/* save flags, always present */
+	movsd
+	/* flag 1 is memory */
+	and	$1, eax
+	je	1f
+	movl	$2, ecx
+	rep movsd
+	/* flag 2 is the command line */
+1:	movl	ebx, eax
+	and	$4, eax
+	je	3f
+	movl    (_boot_multiboot_info_p), eax
+	movl    16(eax), esi
+	movl	$255, ecx
+2:	movzbl	(esi), eax
+	test	al, al
+	je	3f
+	movb	al, (edi)
+	inc	edi
+	inc	esi
+	dec	ecx
+	je	3f
+	jmp	2b
+3:	xor	al, al
+	movb	al, (edi)
 #ifdef DEBUG_EARLY_START
 	/*
 	 * Must get video attribute to have a working printk.
@@ -178,11 +199,10 @@ SYM (zero_bss):
 | Transfer control to User's Board Support Package
 +---------------------------------------------------------------------*/
 
-	pushl	$0			# environp
-	pushl	$0			# argv
-        pushl	$0			# argc
+	movl	$SYM(_boot_multiboot_cmdline), eax
+	pushl	eax			# cmdline
 	call	SYM (boot_card)
-	addl	$12, esp
+	addl	$4, esp
 
 /*---------------------------------------------------------------------+
 | Clean up - we do not know anything about it, so we will
@@ -199,11 +219,20 @@ SYM(_boot_multiboot_info_p):
 	.long 0
 
 	PUBLIC(_boot_multiboot_info)
+	PUBLIC(_boot_multiboot_flags)
+	PUBLIC(_boot_multiboot_memory)
+	PUBLIC(_boot_multiboot_cmdline)
 SYM(_boot_multiboot_info):
+SYM(_boot_multiboot_flags):
 	.long 0	/* flags */
+SYM(_boot_multiboot_memory):
 	.long 0 /* mem_lower */
 	.long 0 /* mem_upper */
-
+SYM(_boot_multiboot_cmdline):
+	.rept 256 /* cmd line */
+	.byte 0
+	.endr
+	
 	PUBLIC(_stack_size)
 SYM(_stack_size):
 	.long STACK_SIZE
Index: c/src/lib/libbsp/i386/pc386/startup/bspcmdline.c
===================================================================
RCS file: c/src/lib/libbsp/i386/pc386/startup/bspcmdline.c
diff -N c/src/lib/libbsp/i386/pc386/startup/bspcmdline.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ c/src/lib/libbsp/i386/pc386/startup/bspcmdline.c	24 Apr 2009 07:09:15 -0000
@@ -0,0 +1,62 @@
+/*-------------------------------------------------------------------------+
+| This file contains the PC386 BSP startup package. It includes application,
+| board, and monitor specific initialization and configuration. The generic CPU
+| dependent initialization has been performed before this routine is invoked.
++--------------------------------------------------------------------------+
+| (C) Copyright 2009 RTEMS Project
+|     Chris Johns (chrisj@rtems.org)
++--------------------------------------------------------------------------+
+| Disclaimer:
+|
+| This file is provided "AS IS" without warranty of any kind, either
+| expressed or implied.
++--------------------------------------------------------------------------+
+| This code is based on:
+|   common sense
+| With the following copyright notice:
+| **************************************************************************
+| *  COPYRIGHT (c) 1989-2008.
+| *  On-Line Applications Research Corporation (OAR).
+| *
+| *  The license and distribution terms for this file may be
+| *  found in found in the file LICENSE in this distribution or at
+| *  http://www.rtems.com/license/LICENSE.
+| **************************************************************************
+|
+|  $Id: bspstart.c,v 1.47 2008/09/18 20:41:09 joel Exp $
++--------------------------------------------------------------------------*/
+
+#include <bsp.h>
+#include <rtems/pci.h>
+#include <libcpu/cpuModel.h>
+
+/*
+ *  External data
+ */
+extern uint32_t _boot_multiboot_flags;
+extern uint32_t _boot_multiboot_memory[2];
+extern const char _boot_multiboot_cmdline[256];
+
+/*-------------------------------------------------------------------------+
+|         Function: bsp_cmdline
+|      Description: Call when you want the command line.
+| Global Variables: The multiboot values copied from the loader.
+|        Arguments: None.
+|          Returns: The whole command line.
++--------------------------------------------------------------------------*/
+const char* bsp_cmdline( void )
+{
+  return _boot_multiboot_cmdline;
+}
+
+/*-------------------------------------------------------------------------+
+|         Function: bsp_cmdline_arg
+|      Description: Call to search for an argument.
+| Global Variables: The multiboot values copied from the loader.
+|        Arguments: The option start.
+|          Returns: The option if found or nothing.
++--------------------------------------------------------------------------*/
+const char* bsp_cmdline_arg( const char* arg )
+{
+  return strstr (bsp_cmdline (), arg);
+}
Index: c/src/lib/libbsp/i386/pc386/startup/bspstart.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/startup/bspstart.c,v
retrieving revision 1.47
diff -p -u -u -r1.47 bspstart.c
--- c/src/lib/libbsp/i386/pc386/startup/bspstart.c	18 Sep 2008 20:41:09 -0000	1.47
+++ c/src/lib/libbsp/i386/pc386/startup/bspstart.c	24 Apr 2009 07:09:15 -0000
@@ -78,6 +78,9 @@ void bsp_start_default( void )
   if (pci_init_retval != PCIB_ERR_SUCCESS) {
       printk("PCI bus: could not initialize PCI BIOS interface\n");
   }
+
+  bsp_ide_cmdline_init ();
+
 } /* bsp_start */
 
 /*
Index: c/src/lib/libbsp/i386/ts_386ex/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/ts_386ex/ChangeLog,v
retrieving revision 1.123
diff -p -u -u -r1.123 ChangeLog
--- c/src/lib/libbsp/i386/ts_386ex/ChangeLog	4 Dec 2008 20:34:02 -0000	1.123
+++ c/src/lib/libbsp/i386/ts_386ex/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/i386/ts_386ex/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/ts_386ex/start/start.S,v
retrieving revision 1.7
diff -p -u -u -r1.7 start.S
--- c/src/lib/libbsp/i386/ts_386ex/start/start.S	21 Apr 2004 16:01:34 -0000	1.7
+++ c/src/lib/libbsp/i386/ts_386ex/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -463,11 +463,9 @@ SYM (zero_bss):
 /*
  *  Transfer control to User's Board Support Package
  */
-        pushl   $0                       # environp
-        pushl   $0                       # argv
-        pushl   $0                       # argc
+        pushl   $0                       # command line
 	call SYM(boot_card)
-        addl    $12,esp
+        addl    $4,esp
 
 	LED_RED                          # Indicate RTEMS exited
 /*
Index: c/src/lib/libbsp/lm32/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/lm32/ChangeLog,v
retrieving revision 1.5
diff -p -u -u -r1.5 ChangeLog
--- c/src/lib/libbsp/lm32/ChangeLog	6 Apr 2009 21:33:48 -0000	1.5
+++ c/src/lib/libbsp/lm32/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* shared/start/start.S: Update for boot_card command line change.
+
 2009-04-06	Michael Walle <michael@walle.cc>
 
 	* shared/start/start.S: Now calls boot_card.
Index: c/src/lib/libbsp/lm32/shared/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/lm32/shared/start/start.S,v
retrieving revision 1.3
diff -p -u -u -r1.3 start.S
--- c/src/lib/libbsp/lm32/shared/start/start.S	6 Apr 2009 21:33:48 -0000	1.3
+++ c/src/lib/libbsp/lm32/shared/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -13,6 +13,11 @@
  *  Micro-Research Finland Oy
  */
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 #include "bspopts.h"
 
      .section .boot,"a",@progbits
@@ -143,8 +148,6 @@ crt0:	
 	bi	.clear_bss
 .end_clear_bss:
 	mvi	r1, 0
-	mvi	r2, 0
-	mvi	r3, 0
 	mvhi	r7, hi(boot_card)
 	ori	r7, r7, lo(boot_card)
 	call	r7
Index: c/src/lib/libbsp/m32c/m32cbsp/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m32c/m32cbsp/ChangeLog,v
retrieving revision 1.3
diff -p -u -u -r1.3 ChangeLog
--- c/src/lib/libbsp/m32c/m32cbsp/ChangeLog	4 Dec 2008 20:32:10 -0000	1.3
+++ c/src/lib/libbsp/m32c/m32cbsp/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs, tools/runtest.in: Move -e start from *link to *startfile
Index: c/src/lib/libbsp/m32c/m32cbsp/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m32c/m32cbsp/start/start.S,v
retrieving revision 1.1
diff -p -u -u -r1.1 start.S
--- c/src/lib/libbsp/m32c/m32cbsp/start/start.S	2 Oct 2008 21:34:35 -0000	1.1
+++ c/src/lib/libbsp/m32c/m32cbsp/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -30,6 +30,11 @@ SOFTWARE, EVEN IF ADVISED OF THE POSSIBI
 
 */
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these errors.
+	
 #if defined(__r8c_cpu__) || defined(__m16c_cpu__)
 #define A16
 #define A(n,w) n
Index: c/src/lib/libbsp/m32r/m32rsim/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m32r/m32rsim/ChangeLog,v
retrieving revision 1.2
diff -p -u -u -r1.2 ChangeLog
--- c/src/lib/libbsp/m32r/m32rsim/ChangeLog	4 Dec 2008 20:32:15 -0000	1.2
+++ c/src/lib/libbsp/m32r/m32rsim/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m32r/m32rsim/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m32r/m32rsim/start/start.S,v
retrieving revision 1.1
diff -p -u -u -r1.1 start.S
--- c/src/lib/libbsp/m32r/m32rsim/start/start.S	2 Oct 2008 21:56:30 -0000	1.1
+++ c/src/lib/libbsp/m32r/m32rsim/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -4,6 +4,11 @@
  *  $Id: start.S,v 1.1 2008/10/02 21:56:30 joel Exp $
  */
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+
 	.text
 	.balign 4
 	.global	_start
Index: c/src/lib/libbsp/m68k/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/ChangeLog,v
retrieving revision 1.52
diff -p -u -u -r1.52 ChangeLog
--- c/src/lib/libbsp/m68k/ChangeLog	16 Sep 2008 22:16:29 -0000	1.52
+++ c/src/lib/libbsp/m68k/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* shared/start/start.S: Update for boot_card command line change.
+
 2008-09-16	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* shared/m68kbspgetworkarea.c: Removed.
Index: c/src/lib/libbsp/m68k/av5282/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/av5282/ChangeLog,v
retrieving revision 1.46
diff -p -u -u -r1.46 ChangeLog
--- c/src/lib/libbsp/m68k/av5282/ChangeLog	21 Jan 2009 18:17:46 -0000	1.46
+++ c/src/lib/libbsp/m68k/av5282/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2009-01-21	Frank Ueberschar <frank.ueberschar@dsa-volgmann.de>
 
 	PR 1354/bsps
Index: c/src/lib/libbsp/m68k/av5282/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/av5282/start/start.S,v
retrieving revision 1.2
diff -p -u -u -r1.2 start.S
--- c/src/lib/libbsp/m68k/av5282/start/start.S	12 Mar 2007 11:18:14 -0000	1.2
+++ c/src/lib/libbsp/m68k/av5282/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -370,13 +370,9 @@ ZEROLOOPTEST:
      * Right : Now we're ready to boot RTEMS
      */
     clrl    d0          | Pass in null to all boot_card() params
-    movel   d0,a7@-         | environp
-    movel   d0,a7@-         | argv
-    movel   d0,a7@-         | argc
+    movel   d0,a7@-         | command line
     jsr SYM(boot_card)      | Call C boot_card function to startup RTEMS
-        movel   a7@+,d0
-        movel   a7@+,d0
-        movel   a7@+,d0
+    movel   a7@+,d0
 MULTI_TASK_EXIT:
         nop
         nop
Index: c/src/lib/libbsp/m68k/csb360/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/csb360/ChangeLog,v
retrieving revision 1.42
diff -p -u -u -r1.42 ChangeLog
--- c/src/lib/libbsp/m68k/csb360/ChangeLog	4 Dec 2008 20:30:44 -0000	1.42
+++ c/src/lib/libbsp/m68k/csb360/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/csb360/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/csb360/start/start.S,v
retrieving revision 1.4
diff -p -u -u -r1.4 start.S
--- c/src/lib/libbsp/m68k/csb360/start/start.S	12 Mar 2007 11:18:16 -0000	1.4
+++ c/src/lib/libbsp/m68k/csb360/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -351,9 +351,7 @@ SYM(start_csb360):
 	 * Right : Now we're ready to boot RTEMS
 	 */
 	clrl	d0			| Pass in null to all boot_card() params
- 	movel	d0,a7@-			| environp
-	movel	d0,a7@-			| argv
-	movel	d0,a7@-			| argc
+	movel	d0,a7@-			| command line
 	jsr	SYM(boot_card)		| Call C boot_card function to startup RTEMS
 
 
Index: c/src/lib/libbsp/m68k/gen68302/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/gen68302/ChangeLog,v
retrieving revision 1.111
diff -p -u -u -r1.111 ChangeLog
--- c/src/lib/libbsp/m68k/gen68302/ChangeLog	4 Dec 2008 20:30:45 -0000	1.111
+++ c/src/lib/libbsp/m68k/gen68302/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/gen68302/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/gen68302/start/start.S,v
retrieving revision 1.8
diff -p -u -u -r1.8 start.S
--- c/src/lib/libbsp/m68k/gen68302/start/start.S	21 Apr 2004 16:01:34 -0000	1.8
+++ c/src/lib/libbsp/m68k/gen68302/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -220,9 +220,7 @@ loop:   movel   d0,a1@+                |
         movec   a0,isp                | set interrupt stack
 #endif
 
-        move.l  #0,a7@-               | environp
-        move.l  #0,a7@-               | argv
-        move.l  #0,a7@-               | argc
+        move.l  #0,a7@-               | command line
         jsr     SYM (boot_card)
 
 	nop
Index: c/src/lib/libbsp/m68k/gen68340/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/gen68340/ChangeLog,v
retrieving revision 1.114
diff -p -u -u -r1.114 ChangeLog
--- c/src/lib/libbsp/m68k/gen68340/ChangeLog	27 Feb 2009 19:19:46 -0000	1.114
+++ c/src/lib/libbsp/m68k/gen68340/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2009-02-27	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* Makefile.am: Remove unnecessary copy of cpu_asm.S
Index: c/src/lib/libbsp/m68k/gen68340/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/gen68340/start/start.S,v
retrieving revision 1.13
diff -p -u -u -r1.13 start.S
--- c/src/lib/libbsp/m68k/gen68340/start/start.S	17 Oct 2006 02:35:11 -0000	1.13
+++ c/src/lib/libbsp/m68k/gen68340/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -848,9 +848,7 @@ ZEROLOOPTEST:
 	bcs.s	ZEROLOOP					| No, skip
 
 	movel	#_stack_init,a7					| set master stack pointer
-	movel	d0,a7@-						| environp
-	movel	d0,a7@-						| argv
-	movel	d0,a7@-						| argc
+	movel	d0,a7@-						| command line
 	jsr	SYM(boot_card)					| Call C main
 
 	PUBLIC (_mainDone)
Index: c/src/lib/libbsp/m68k/gen68360/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/gen68360/ChangeLog,v
retrieving revision 1.121
diff -p -u -u -r1.121 ChangeLog
--- c/src/lib/libbsp/m68k/gen68360/ChangeLog	4 Dec 2008 20:30:47 -0000	1.121
+++ c/src/lib/libbsp/m68k/gen68360/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/gen68360/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/gen68360/start/start.S,v
retrieving revision 1.11
diff -p -u -u -r1.11 start.S
--- c/src/lib/libbsp/m68k/gen68360/start/start.S	16 Sep 2008 19:03:17 -0000	1.11
+++ c/src/lib/libbsp/m68k/gen68360/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -393,9 +393,7 @@ ZEROLOOPTEST:
 	bcs.s	ZEROLOOP		| No, skip
 
 	movel	#_stack_init,a7		| set master stack pointer
-	pea	env			| envp
-	pea	arg			| argv
-	movel	d0,a7@-			| argc
+	movel	d0,a7@-			| command line
 	jsr	boot_card		| Call C main
 
 	PUBLIC (_mainDone)
@@ -413,15 +411,10 @@ BEGIN_DATA_DCL
         .align 2
 	PUBLIC (environ)
 environ:
-	.long	env
+	.long	0
 	PUBLIC (_M68kSpuriousInterruptCount)
 _M68kSpuriousInterruptCount:
 	.long	0
 END_DATA_DCL
 
-BEGIN_BSS
-env:	.long	0
-arg:	.long	0
-END_BSS
-
 END
Index: c/src/lib/libbsp/m68k/genmcf548x/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/genmcf548x/ChangeLog,v
retrieving revision 1.25
diff -p -u -u -r1.25 ChangeLog
--- c/src/lib/libbsp/m68k/genmcf548x/ChangeLog	4 Dec 2008 20:30:48 -0000	1.25
+++ c/src/lib/libbsp/m68k/genmcf548x/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/genmcf548x/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/genmcf548x/start/start.S,v
retrieving revision 1.1
diff -p -u -u -r1.1 start.S
--- c/src/lib/libbsp/m68k/genmcf548x/start/start.S	11 Jul 2008 10:00:41 -0000	1.1
+++ c/src/lib/libbsp/m68k/genmcf548x/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -414,15 +414,11 @@ SYM(start_init):
     move.l  #_SpInit,sp		        /* relocate sp */ 
      
     clrl    d0          		/* clear d0 */
-    movel   d0,a7@-                     /* environp == NULL */
-    movel   d0,a7@-                     /* argv == NULL */
-    movel   d0,a7@-                     /* argc == 0 */
+    movel   d0,a7@-                     /* command line == 0 */
  
     jsr     boot_card                   /* boot rtems */
 
     movel   a7@+,d0
-    movel   a7@+,d0
-    movel   a7@+,d0
 
 exit_multitasking:
     nop
Index: c/src/lib/libbsp/m68k/mcf5206elite/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mcf5206elite/ChangeLog,v
retrieving revision 1.100
diff -p -u -u -r1.100 ChangeLog
--- c/src/lib/libbsp/m68k/mcf5206elite/ChangeLog	4 Dec 2008 20:30:50 -0000	1.100
+++ c/src/lib/libbsp/m68k/mcf5206elite/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* startup/init52235.c: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/mcf5206elite/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mcf5206elite/start/start.S,v
retrieving revision 1.8
diff -p -u -u -r1.8 start.S
--- c/src/lib/libbsp/m68k/mcf5206elite/start/start.S	16 Sep 2008 19:03:23 -0000	1.8
+++ c/src/lib/libbsp/m68k/mcf5206elite/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -357,9 +357,7 @@ ZEROLOOPTEST:
 	 * Right : Now we're ready to boot RTEMS
 	 */
 	clrl	d0			| Pass in null to all boot_card() params
- 	movel	d0,a7@-			| environp
-	movel	d0,a7@-			| argv
-	movel	d0,a7@-			| argc
+	movel	d0,a7@-			| command line
 	jsr	SYM(boot_card)		| Call C boot_card function to startup RTEMS
 
 # Wait forever
Index: c/src/lib/libbsp/m68k/mcf52235/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mcf52235/ChangeLog,v
retrieving revision 1.23
diff -p -u -u -r1.23 ChangeLog
--- c/src/lib/libbsp/m68k/mcf52235/ChangeLog	4 Dec 2008 20:30:51 -0000	1.23
+++ c/src/lib/libbsp/m68k/mcf52235/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/mcf52235/startup/init52235.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mcf52235/startup/init52235.c,v
retrieving revision 1.3
diff -p -u -u -r1.3 init52235.c
--- c/src/lib/libbsp/m68k/mcf52235/startup/init52235.c	19 Aug 2008 11:14:43 -0000	1.3
+++ c/src/lib/libbsp/m68k/mcf52235/startup/init52235.c	24 Apr 2009 07:09:16 -0000
@@ -8,7 +8,7 @@
 
 extern void _wr_vbr(uint32_t);
 extern void init_main(void);
-extern int boot_card(int, char **, char **);
+extern int boot_card(const char *);
 
 /*
  * From linkcmds
@@ -76,6 +76,6 @@ void Init52235(void)
    * We have to call some kind of RTEMS function here!
    */
 
-  boot_card(0, 0, 0);
+  boot_card(0);
   for (;;) ;
-}
\ No newline at end of file
+}
Index: c/src/lib/libbsp/m68k/mcf5235/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mcf5235/ChangeLog,v
retrieving revision 1.49
diff -p -u -u -r1.49 ChangeLog
--- c/src/lib/libbsp/m68k/mcf5235/ChangeLog	4 Dec 2008 20:30:52 -0000	1.49
+++ c/src/lib/libbsp/m68k/mcf5235/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/mcf5235/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mcf5235/start/start.S,v
retrieving revision 1.3
diff -p -u -u -r1.3 start.S
--- c/src/lib/libbsp/m68k/mcf5235/start/start.S	11 Jun 2008 08:03:50 -0000	1.3
+++ c/src/lib/libbsp/m68k/mcf5235/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -368,13 +368,9 @@ ZEROLOOPTEST:
      * Right : Now we're ready to boot RTEMS
      */
     clrl    d0          | Pass in null to all boot_card() params
-    movel   d0,a7@-         | environp
-    movel   d0,a7@-         | argv
-    movel   d0,a7@-         | argc
+    movel   d0,a7@-         | command line
     jsr SYM(boot_card)      | Call C boot_card function to startup RTEMS
         movel   a7@+,d0
-        movel   a7@+,d0
-        movel   a7@+,d0
 MULTI_TASK_EXIT:
         nop
         nop
Index: c/src/lib/libbsp/m68k/mcf5329/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mcf5329/ChangeLog,v
retrieving revision 1.22
diff -p -u -u -r1.22 ChangeLog
--- c/src/lib/libbsp/m68k/mcf5329/ChangeLog	4 Dec 2008 20:30:54 -0000	1.22
+++ c/src/lib/libbsp/m68k/mcf5329/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* startup/init5329.c: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/mcf5329/startup/init5329.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mcf5329/startup/init5329.c,v
retrieving revision 1.2
diff -p -u -u -r1.2 init5329.c
--- c/src/lib/libbsp/m68k/mcf5329/startup/init5329.c	19 Aug 2008 11:19:19 -0000	1.2
+++ c/src/lib/libbsp/m68k/mcf5329/startup/init5329.c	24 Apr 2009 07:09:16 -0000
@@ -9,7 +9,7 @@
 
 extern void _wr_vbr(uint32_t);
 extern void init_main(void);
-extern int boot_card(int, char **, char **);
+extern int boot_card(const char *);
 
 /*
  * From linkcmds
@@ -77,6 +77,6 @@ void Init5329(void)
    * We have to call some kind of RTEMS function here!
    */
 
-  boot_card(0, 0, 0);
+  boot_card(0);
   for (;;) ;
 }
Index: c/src/lib/libbsp/m68k/mrm332/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mrm332/ChangeLog,v
retrieving revision 1.115
diff -p -u -u -r1.115 ChangeLog
--- c/src/lib/libbsp/m68k/mrm332/ChangeLog	4 Dec 2008 20:30:55 -0000	1.115
+++ c/src/lib/libbsp/m68k/mrm332/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,8 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S, startup/start_c.c: Update for boot_card command
+	line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/mrm332/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mrm332/start/start.S,v
retrieving revision 1.5
diff -p -u -u -r1.5 start.S
--- c/src/lib/libbsp/m68k/mrm332/start/start.S	21 Apr 2004 16:01:35 -0000	1.5
+++ c/src/lib/libbsp/m68k/mrm332/start/start.S	24 Apr 2009 07:09:16 -0000
@@ -142,7 +142,7 @@ END_CODE
   /*
    * Execute main with arguments argc and agrv.
    */
-  boot_card(1,__argv);
+  boot_card((void*)0);
   reboot();
 
 }
Index: c/src/lib/libbsp/m68k/mrm332/startup/start_c.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/mrm332/startup/start_c.c,v
retrieving revision 1.7
diff -p -u -u -r1.7 start_c.c
--- c/src/lib/libbsp/m68k/mrm332/startup/start_c.c	19 Aug 2008 10:23:15 -0000	1.7
+++ c/src/lib/libbsp/m68k/mrm332/startup/start_c.c	24 Apr 2009 07:09:16 -0000
@@ -9,9 +9,8 @@
 
 m68k_isr_entry M68Kvec[256];
 m68k_isr_entry vectors[256];
-char * const __argv[]= {"main", ""};
 
-void  boot_card(int argc, char * const argv[]);
+void  boot_card(const char *cmdline);
 
 /*
  *  This prototype really should have the noreturn attribute but
@@ -119,7 +118,7 @@ void start_c(void) {
   /*
    * Execute main with arguments argc and agrv.
    */
-  boot_card(1,__argv);
+  boot_card((void*)0);
   reboot();
 
 }
Index: c/src/lib/libbsp/m68k/ods68302/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/ods68302/ChangeLog,v
retrieving revision 1.118
diff -p -u -u -r1.118 ChangeLog
--- c/src/lib/libbsp/m68k/ods68302/ChangeLog	4 Dec 2008 20:31:06 -0000	1.118
+++ c/src/lib/libbsp/m68k/ods68302/ChangeLog	24 Apr 2009 07:09:16 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* startup/cpuboot.c: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/m68k/ods68302/startup/cpuboot.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/ods68302/startup/cpuboot.c,v
retrieving revision 1.9
diff -p -u -u -r1.9 cpuboot.c
--- c/src/lib/libbsp/m68k/ods68302/startup/cpuboot.c	19 Aug 2008 09:15:36 -0000	1.9
+++ c/src/lib/libbsp/m68k/ods68302/startup/cpuboot.c	24 Apr 2009 07:09:16 -0000
@@ -119,7 +119,7 @@ void boot_phase_2(void)
   static constructors have not been called, and RTEMS is not initialised.
   */
 
-void boot_card(void);
+void boot_card(const char* cmdline);
 void set_debug_traps(void);
 void breakpoint(void);
 
@@ -136,7 +136,7 @@ void boot_phase_3(void)
   /* FIXME : add RAM and ROM checks */
 
   /* boot the bsp, what ever this means */
-  boot_card();
+  boot_card((void*)0);
 
   WATCHDOG_TRIGGER();
 }
Index: c/src/lib/libbsp/m68k/shared/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/m68k/shared/start.S,v
retrieving revision 1.9
diff -p -u -u -r1.9 start.S
--- c/src/lib/libbsp/m68k/shared/start.S	15 Apr 2004 13:26:15 -0000	1.9
+++ c/src/lib/libbsp/m68k/shared/start.S	24 Apr 2009 07:09:16 -0000
@@ -91,9 +91,7 @@ loop:   movel   #0,a1@+                 
         lea     SYM (hiintstack),a0   | a0 = high end of intr stack
         movec   a0,isp                | set interrupt stack
 #endif
-        pea	env                   | push environp
-        pea	arg                   | push argv
-        movel   #0,a7@-               | push argc
+        movel   #0,a7@-               | push command line
 
         jsr     SYM (boot_card)
         addl    #12,a7
@@ -118,7 +116,7 @@ BEGIN_DATA
 	PUBLIC (environ)
         .align 2
 SYM (environ):
-	.long	env
+	.long	0
 
 	PUBLIC (start_frame)
 SYM (start_frame):
@@ -128,9 +126,6 @@ END_DATA
 
 BEGIN_BSS
 
-env: .long  0
-arg: .long  0
-
 	PUBLIC (initial_isp)
 SYM (initial_isp):
         .space  4
